#Computes the periodic spline basis Zp and the gram matrix Gp

# Base spline, dim p : 
cat(paste("p=",p),"\n")
## Base spline : 
x = (1:p)/p	# Les knots
rp = p-1;	# Dimension de la base spline
X =matrix(data = x,nrow = p,ncol = 1) 

Y0 =diag(x=1,nrow = rp+1,ncol = rp+1)
Y0=Y0[1:rp,1:(rp+1)]
Y0[1,(rp+1)]=1
Y0=t(Y0)
Y1 = Y2 = Y3 = matrix(data=0,nrow=p,ncol=rp)
for (i in 1:rp){
  
  f <- splinefun(X,Y0[,i],method = "periodic")
  Y1[,i] = f(X,deriv=1);#deriv??e en les noeuds de la iemme fonction de base
  Y2[,i] = f(X,deriv=2);
  Y3[,i] = f(X,deriv=3);
}

## Matrice B :
Zp = Y0[1:p,]
## Matrice G :
Gp=G0=matrix(data = 0,nrow=dim(t(Zp)%*%Zp)[1],ncol = dim(t(Zp)%*%Zp)[2]) 
#calcul de la matrice de Gram
interv = X[2:p] - X[1:(p-1)]
interv =matrix(data = interv,nrow = length(interv),ncol = 1)
Interv = interv%*% matrix(data = 1, nrow =1,ncol =length(Y2[1,])  )  

for(s1 in 1:rp){ 
  #nombre de noeuds copies en colonnes des deriv??e secondes et troisi??mes 
  #en les noeuds sauf le dernier pour la s1 ieme fct de base spline
  
  f2 = Y2[1:(dim(Y2)[1]-1),s1]%*% matrix(data = 1, nrow =1,ncol =length(Y2[1,])  )  
  f3 = Y3[1:(dim(Y3)[1]-1),s1]%*% matrix(data = 1, nrow =1,ncol =length(Y2[1,])  )  
  #deriv?? des fonction de base arrang??e en colonnes 
  #sur tout les noeud sauf le dernier
  g2 = Y2[1:(dim(Y2)[1]-1),]
  g3 = Y3[1:(dim(Y3)[1]-1),]
  Int = f2 * g2 *Interv + (f2 * g3 + g2 * f3)*Interv^2/2 + f3 * g3 *Interv^3/3
  ## Pour comprendre ce calcul, il faut revenir ?? la d??finition de G et d??velopper le produit des d??riv??es secondes sur chaque intervalle...
  Gp[s1,] =apply(Int, 2, sum)   
}

## H, Gamma :
# Hp = t(Zp)%*%Up1%*%Zp + rho_p * Gp
# Hp1 = solve(Hp)
# Gamma_p = Zp %*% Hp1 %*% t(Zp)
